/*
 * File: dpvmError.h
 *
 * ABSTRACT:
 *  Routines for error handling
 * 
 * (C) University of Amsterdam 
 *     Section Computational Science 
 *     Kruislaan 403, the Netherlands
 *
 * CREATION DATE: 30-08-1999
 * AUTHOR       : Z.W. Hendrikse
 * 
 * MODIFICATION HISTORY:
 * 
 * Date        By    Description
 * ----------  ----  -----------------------------------
 */

#ifndef _dpvmError_h_
#define _dpvmError_h_

#define ERR_NORMAL      0       /* normal error message */
#define ERR_DEBUG       1       /* debug message */
#define ERR_FATAL       2       /* exit(1) after printing message */
#define ERR_PERR        4       /* print system error message as well */

/**
 * Construct an error message.
 * <err_type> is ERR_NORMAL, ERR_DEBUG, ERR_FATAL or ERR_PERR
 */
extern void error(int err_type, char *fmt, ...);

#endif
